//----------------------------------------------------------------------//
// NyanFi																//
//  fBNg/ X^bN											//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <RegularExpressions.hpp>
#include "UserFunc.h"
#include "Global.h"
#include "MainFrm.h"
#include "HistDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDirHistoryDlg *DirHistoryDlg;

//---------------------------------------------------------------------------
__fastcall TDirHistoryDlg::TDirHistoryDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, DirHistListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);

	IsDirStack = IsAllDirHist = IsFindDirHist = false;
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);
	IsMigemo = IniFile->ReadBoolGen(_T("DirHistoryMigemo"));

	RefListTag	 = CurListTag;
	WorkListName = EmptyStr;

	HdrPanel->ClientHeight = get_FontHeight(ListFont, 4, 4);
	HdrPanel->Font->Assign(ListFont);
	HdrPanel->Color 	  = col_bgList;
	HdrPanel->Font->Color = col_fgList;
	HdrPanel->Caption = IncSeaWord = EmptyStr;
	HdrPanel->Visible = IsFindDirHist;

	set_StdListBox(DirHistListBox);
	set_UsrScrPanel(ListScrPanel);

	int *h_ptr = (IsDirStack || IsAllDirHist)? NULL : get_DirHistPtr(CurTabIndex, CurListTag);
	UpdateListBox(h_ptr? *h_ptr : 0);
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IsDirStack = IsAllDirHist = IsFindDirHist = false;

	IniFile->SavePosInfo(this);
	IniFile->WriteBoolGen(_T("DirHistoryMigemo"), IsMigemo);
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
//ꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::UpdateListBox(
	int idx)	//CfbNX	(default = 0)
{
	TListBox *lp = DirHistListBox;
	lp->Clear();

	UnicodeString tit;
	if (IsDirStack)
		tit.USET_T("fBNgEX^bN");
	else if (IsFindDirHist)
		tit.USET_T("fBNg - Š");
	else if (IsAllDirHist)
		tit.USET_T("fBNg - S");
	else {
		tit.sprintf(_T("fBNg - %s"), get_LRUD_str(RefListTag).c_str());
		if (RefListTag!=CurListTag) tit.UCAT_T(" (ΑQ)");
	}
	Caption = tit;

	//tB^[h
	if (IsFindDirHist) {
		HdrPanel->Caption = (IsMigemo? " Migemo: " : "") + IncSeaWord;
		HdrPanel->Repaint();
		std::unique_ptr<TStringList> f_lst(new TStringList());
		UnicodeString lbuf;
		if (IsMigemo) {
			UnicodeString ptn = usr_Migemo->GetRegExPtn(true, IncSeaWord);
			if (!ptn.IsEmpty()) {
				TRegExOptions opt; opt << roIgnoreCase;
				for (int i=0; i<AllDirHistory->Count; i++) {
					lbuf = AllDirHistory->Strings[i];
					if (TRegEx::IsMatch(get_csv_item(lbuf, 0), ptn, opt)) f_lst->Add(lbuf);
				}
			}
		}
		else {
			for (int i=0; i<AllDirHistory->Count; i++) {
				lbuf = AllDirHistory->Strings[i];
				if (ContainsText(get_csv_item(lbuf, 0), IncSeaWord)) f_lst->Add(lbuf);
			}
		}
		lp->Items->Assign(!IncSeaWord.IsEmpty()? f_lst.get() : AllDirHistory);
	}
	//ʏ탂[h
	else {
		TStringList *h_lst = IsDirStack? DirStack : IsAllDirHist? AllDirHistory : get_DirHistory(CurTabIndex, RefListTag);
		if (h_lst) lp->Items->Assign(h_lst);
	}

	if (lp->Count>0) lp->ItemIndex = (idx<lp->Count)? idx : lp->Count - 1;
	lp->SetFocus();
	ListScrPanel->UpdateKnob();
}

//---------------------------------------------------------------------------
//ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv = lp->Canvas;
	cv->Font->Assign(ListFont);
	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin2(cv);

	if (!IsFindDirHist) {
		if (Index<10) {
			cv->Font->Color = col_fgList;
			cv->Font->Style = cv->Font->Style << fsUnderline;
			cv->TextOut(xp, yp, UnicodeString().sprintf(_T("%u"), (Index + 1)%10));
		}
		cv->Font->Style = cv->Font->Style >> fsUnderline;
		xp += get_CharWidth(cv, 2);
	}

	UnicodeString lbuf = get_csv_item(lp->Items->Strings[Index], 0);
	if (UncToNetDrive) lbuf = UNC_to_NetDriveName(lbuf);
	if (DispRegName)   lbuf = get_RegDirName(lbuf);
	lbuf = yen_to_slash(lbuf);

	cv->Font->Color = col_Folder;
	cv->TextOut(xp, yp, lbuf);

	//J[\
	draw_ListCursor2(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxKeyDown(TObject *Sender, WORD &Key,
		TShiftState Shift)
{
	TListBox *lp = (TListBox*)Sender;
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);
	UnicodeString cmd_S  = IsFindDirHist? KeyFuncList->Values["S:" + KeyStr] : EmptyStr;
	bool handled = true;

	try {
		bool is_all = (IsAllDirHist || IsFindDirHist);
		TStringList *h_lst = is_all? AllDirHistory :
						 IsDirStack? DirStack : get_DirHistory(CurTabIndex, RefListTag);
		int *h_ptr = (IsDirStack || IsAllDirHist || IsFindDirHist)? NULL : get_DirHistPtr(CurTabIndex, CurListTag);
		UnicodeString lst_itm = (lp->ItemIndex!=-1)? lp->Items->Strings[lp->ItemIndex] : EmptyStr;

		//m
		if ((!IsFindDirHist && is_Num0to9(KeyStr)) || equal_ENTER(KeyStr)) {
			int idx = is_Num0to9(KeyStr)? ((KeyStr.ToIntDef(0) + 9)%10) : lp->ItemIndex;
			if (idx<0 || idx>=lp->Count) Abort();
			UnicodeString dnam = get_csv_item(lp->Items->Strings[idx], 0);
			//fBNg
			if (ends_PathDlmtr(dnam)) {
				if (dir_exists(dnam)) {
					bool is_cur = (RefListTag==CurListTag);
					if (!is_all && is_cur && h_ptr) *h_ptr = idx;
					NyanFiForm->UpdateCurPath(dnam, -1, is_cur);
					ModalResult = mrOk;
				}
				else {
					msgbox_WARN(USTR_NotFound);
					//݂ȂfBNg폜
					if (h_lst) {
						int i = 0;
						while (i<h_lst->Count) {
							if (SameText(dnam, get_csv_item(h_lst->Strings[i], 0))) h_lst->Delete(i); else i++;
						}
						UpdateListBox(idx);
					}
				}
			}
			//[NXg
			else if (test_NwlExt(get_extension(dnam))) {
				WorkListName = dnam;
				ModalResult  = mrOk;
			}
		}
		//tB^
		else if (IsFindDirHist && update_IncSeaWord(IncSeaWord, KeyStr)) {
			UpdateListBox();
		}
		else if (USAME_TI(cmd_S, "ClearIncKeyword")) {
			IncSeaWord = EmptyStr;
			UpdateListBox();
		}
		else if (USAME_TI(cmd_S, "MigemoMode")) {
			IsMigemo = (!IsMigemo && usr_Migemo->DictReady);
			UpdateListBox();
		}
		//J[\ړ
		else if (USAME_TI(cmd_S, "IncSearchUp"))	ListBoxCursorUp(lp);
		else if (USAME_TI(cmd_S, "IncSearchDown"))	ListBoxCursorDown(lp);
		else if	(ExeCmdListBox(lp, cmd_F))			;
		//ڂ̍폜
		else if (!IsFindDirHist && (equal_DEL(KeyStr) || USAME_TI(cmd_F, "Delete"))) {
			if (lp->ItemIndex==-1) Abort();
			if (h_lst) h_lst->Delete(lp->ItemIndex);
			UpdateListBox(lp->ItemIndex);
		}
		//Α̗Q
		else if (!IsFindDirHist && (equal_RIGHT(KeyStr) || contained_wd_i(_T("ToRight|ToParentOnRight"), cmd_F))) {
			if (h_ptr && RefListTag==0) {
				RefListTag = 1;
				int *h_p = get_DirHistPtr(CurTabIndex, RefListTag);
				if (h_p) UpdateListBox(*h_p);
			}
		}
		else if (!IsFindDirHist && (equal_LEFT(KeyStr) || contained_wd_i(_T("ToLeft|ToParentOnLeft"), cmd_F))) {
			if (h_ptr && RefListTag==1) {
				RefListTag = 0;
				int *h_p = get_DirHistPtr(CurTabIndex, RefListTag);
				if (h_p) UpdateListBox(*h_p);
			}
		}
		//
		else if (USAME_TI(cmd_F, "ReturnList"))	ModalResult = mrCancel;
		else handled = false;
	}
	catch (EAbort &e) {
		beep_Warn();
	}

	if (!is_DialogKey(Key) || handled) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key)) Key = 0;
}
//---------------------------------------------------------------------------
//}EX
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxDblClick(TObject *Sender)
{
	perform_Key_RETURN((TControl*)Sender);
}

//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}

//---------------------------------------------------------------------------
//ׂč폜
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::ClearAllActionExecute(TObject *Sender)
{
	if (IsAllDirHist || IsFindDirHist) {
		if (msgbox_Sure(LoadUsrMsg(USTR_DelHistoryQ, _T("S")))) {
			DirHistListBox->Clear();
			AllDirHistory->Clear();
		}
	}
	else if (!IsDirStack) {
		if (msgbox_Sure(LoadUsrMsg(USTR_DelHistoryQ, get_LRUD_str().UCAT_T("")))) {
			DirHistListBox->Clear();
			clear_DirHistory(CurTabIndex, CurListTag);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::ClearAllActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;
	ap->Enabled = !IsDirStack;
	ap->Caption = (IsAllDirHist || IsFindDirHist)? "Sׂ̗č폜(&A)" : "Jgׂ̗č폜(&A)";
}
//---------------------------------------------------------------------------

